﻿using System;
using System.Linq;
using System.Xml;
using System.Collections.Generic;
using UnityEngine;
using System.IO;

public static class PrefabSpawnRangeMethod
{
    public static bool IsSpawn(RWG2.Rules.PrefabInfo prefabInfo,Vector2 pos)
    {
        if(prefabInfo == null)
        {
            return false;
        }
        Prefab prefab = RWG2.Rules.RWGRules.Instance.GetPrefab(prefabInfo.Name);
        float range = pos.magnitude;
        if (prefab.WorldSpawnRangeMin > 0 && range < prefab.WorldSpawnRangeMin)
        {
            return false;
        }
        if (prefab.WorldSpawnRangeMax > 0 && range > prefab.WorldSpawnRangeMax)
        {
            return false;
        }
        return true;

    }
    //Prefab.CW
    public static void GetPrefabSpawnRangeProperty(Prefab prefab)
    {
        if (prefab.properties.Values.ContainsKey("WorldSpawnRangeMin"))
        {

            prefab.WorldSpawnRangeMin = float.Parse(prefab.properties.GetStringValue("WorldSpawnRangeMin"));
        }
        else
        {
            prefab.WorldSpawnRangeMin = 0.0f;

        }
        if (prefab.properties.Values.ContainsKey("WorldSpawnRangeMax"))
        {

            prefab.WorldSpawnRangeMax = float.Parse(prefab.properties.GetStringValue("WorldSpawnRangeMax"));
        }
        else
        {
            prefab.WorldSpawnRangeMax = 0.0f;

        }

    }
    //Prefab.OW
    public static void GetPrefabSpawnRangeToProperty(Prefab prefab)
    {
        if (!(prefab.WorldSpawnRangeMin == 0)
           )
        {
            prefab.properties.Values["WorldSpawnRangeMin"] = prefab.WorldSpawnRangeMin.ToString();
        }
        if (!(prefab.WorldSpawnRangeMax == 0)
           )
        {
            prefab.properties.Values["WorldSpawnRangeMax"] = prefab.WorldSpawnRangeMax.ToString();
        }

    }
    public static void CopyPrefabData(Prefab src, Prefab dst)
    {
        dst.WorldSpawnRangeMin = src.WorldSpawnRangeMin;
        dst.WorldSpawnRangeMax = src.WorldSpawnRangeMax;
    }

}
